select
    an.numero as "Animal"
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as "Raa"
    , an.dtnascimento as "Nascimento"
    , lac.dtinicio as "Incio Lactao"
    , cast((case when lac.dtfim is null then 'Aberta' else (lpad(extract(day from lac.dtfim), 2, '0') || '/' || lpad(extract(month from lac.dtfim), 2,'0') || '/' || substring(extract(year from lac.dtfim) from 3 for 2)) end) as varchar(8)) as "Fim Lactao"
    , (select count(*) from lactacao where cdanimal = lac.cdanimal and dtinicio <= lac.dtinicio) as "Ordem Lactao"
    , ((select count(*) from reproducao where cdanimal = lac.cdanimal and data <= lac.dtinicio and cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) as "Ordem Parto"
    , ((select count(*) from reproducao where cdanimal = lac.cdanimal and data <= lac.dtinicio and cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0) - 1) as "Partos Anteriores"
    , ((select count(*) from lactacao where cdanimal = lac.cdanimal and dtinicio <= lac.dtinicio) - 1) as "Lactaes Anteriores"
    , lacA.dtinicio as "Incio Lactao Antes"
    , lacA.dtfim as "Fim Lactao Antes"
    , (case when lac.dtfim is null then 'Aberta' else (lac.dtfim - lac.dtinicio) end) as "Durao da Lactao"
    , (select first 1 valor from medida where cdtipomedida = 2 and cdanimal = lac.cdanimal and dtmedida between (lac.dtfim - 30) and (lac.dtfim) order by dtmedida desc) as "Escore Corporal Secagem"
    , (case when lac.dtfim is not null then ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtfim - 13) and (lac.dtfim - 7))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtfim - 13) and (lac.dtfim - 7))) else null end) as "Mdia Penltima Semana"
    , (case when lac.dtfim is not null then ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtfim - 6) and (lac.dtfim - 0))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtfim - 6) and (lac.dtfim - 0))) else null end) as "Mdia ltima Semana"
    , ccs.ccs as "CCS Secagem"
    , (case par.qualidadecolostro
        when 0 then 'Baixa'
        when 1 then 'Mdia'
        when 2 then 'Alta'
        else NULL end) as "Qualidade Colostro"
    , (coalesce(par.sexocria1, cria1.sexo, null)) as "Sexo Cria 1"
    , (coalesce(par.sexocria2, cria2.sexo, null)) as "Sexo Cria 2"
    , (lac.dtinicio - rep.data) as "Dias Gestante"
    , (select first 1 ccs from analiseleite where cdanimal = lac.cdanimal and ccs is not null and dtanaliseleite between lac.dtinicio and lac.dtfim order by dtanaliseleite asc) as "Primeira CCS"
    , m1.data as "Mastite 1"                                                                                                
    , m2.data as "Mastite 2"
    , m3.data as "Mastite 3"
    , m4.data as "Mastite 4"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between lac.dtinicio and (lac.dtinicio + 6))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between lac.dtinicio and (lac.dtinicio + 6))) as "Mdia 01 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 7) and (lac.dtinicio + 13))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 7) and (lac.dtinicio + 13))) as "Mdia 02 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 14) and (lac.dtinicio + 20))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 14) and (lac.dtinicio + 20))) as "Mdia 03 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 21) and (lac.dtinicio + 27))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 21) and (lac.dtinicio + 27))) as "Mdia 04 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 28) and (lac.dtinicio + 34))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 28) and (lac.dtinicio + 34))) as "Mdia 05 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 35) and (lac.dtinicio + 41))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 35) and (lac.dtinicio + 41))) as "Mdia 06 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 42) and (lac.dtinicio + 48))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 42) and (lac.dtinicio + 48))) as "Mdia 07 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 49) and (lac.dtinicio + 55))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 49) and (lac.dtinicio + 55))) as "Mdia 08 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 56) and (lac.dtinicio + 62))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 56) and (lac.dtinicio + 62))) as "Mdia 09 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 63) and (lac.dtinicio + 69))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 63) and (lac.dtinicio + 69))) as "Mdia 10 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 70) and (lac.dtinicio + 76))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 70) and (lac.dtinicio + 76))) as "Mdia 11 Semana"
    , ((select sum(pesototal) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 77) and (lac.dtinicio + 83))/(select count(*) from leite where cdanimal = lac.cdanimal and dtleite between (lac.dtinicio + 77) and (lac.dtinicio + 83))) as "Mdia 12 Semana"
    , (case cat150.creprodutiva
        when 1 then 'Insem./Cob.'
        when 2 then 'Implant.'
        when 3 then 'Gestante'
        when 4 then 'Vazia' || ': ' || (case cat150.sreprodutiva
                                            when 1 then 'Apta'
                                            when 2 then 'Atrasada'
                                            when 3 then 'PEV'
                                            else cat150.sreprodutiva end)
        else cat150.creprodutiva end) as "Categoria 150 dias"
    , (rep.data - parA.data) as "Intervalo Concepo"
    , (case when ia1dig.diagnostico = 'P' then 'Sim' else 'No' end) as "Concebeu 1 Tentativa"
    , (ia1.data) as "Data 1 Tentativa"
from lactacao lac                               
    join animal an on an.cdanimal = lac.cdanimal
    join reproducao rep on rep.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = lac.cdanimal
                and re.data < lac.dtinicio
                and re.cdtiporeproducao in (1,2,3)
            order by re.data desc)
    join reproducao par on par.cdreproducao =
        (select re.cdreproducao from reproducao re where re.cdanimal = lac.cdanimal and re.data = lac.dtinicio and re.cdtiporeproducao = 7)
    left join reproducao parA on parA.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = lac.cdanimal and re.data < lac.dtinicio and re.cdtiporeproducao = 7 order by re.data desc)
    left join lactacao lacA on lacA.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = lac.cdanimal and re.dtinicio < lac.dtinicio order by re.dtinicio desc)
    left join analiseleite ccs on ccs.cdanaliseleite =
        (select first 1 re.cdanaliseleite
            from analiseleite re
            where re.cdanimal = lac.cdanimal
                and re.ccs is not null
                and re.dtanaliseleite between (lac.dtfim - 30) and (lac.dtfim)
            order by re.dtanaliseleite desc)
    join sp_categoriaanimal((lac.dtinicio + 150), 'cdanimal = '||lac.cdanimal) cat150 on 1=1
    join reproducao pripar on pripar.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdtiporeproducao = 7 and re.cdanimal = lac.cdanimal order by re.data asc)
    left join animal cria1 on cria1.cdanimal =
        (select first 1 cdanimal from animal re where re.cdreproducao = par.cdreproducao order by cdanimal asc)
    left join animal cria2 on cria2.cdanimal =
        (select first 1 cdanimal from animal re where re.cdreproducao = par.cdreproducao and cdanimal > cria1.cdanimal order by cdanimal asc)
    left join mamite m1 on m1.cdmamite =
        (select first 1 m.cdmamite
            from mamite m
            where
                (((m.ad in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ad in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pd in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pd in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.ae in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ae in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pe in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pe in (0,1,2) and re.data between (m.data-13) and (m.data-1)))))
                and m.data >= lac.dtinicio
                and m.data <= coalesce(lac.dtfim, current_date)
                and m.cdanimal = lac.cdanimal
            order by m.data asc)
    left join mamite m2 on m2.cdmamite =
        (select first 1 m.cdmamite
            from mamite m
            where
                (((m.ad in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ad in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pd in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pd in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.ae in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ae in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pe in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pe in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) )
                and m.data >= lac.dtinicio
                and m.data <= coalesce(lac.dtfim, current_date)
                and m.cdanimal = lac.cdanimal
                and m.data > m1.data
            order by m.data asc)
    left join mamite m3 on m3.cdmamite =
        (select first 1 m.cdmamite
            from mamite m
            where
                (((m.ad in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ad in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pd in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pd in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.ae in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ae in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pe in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pe in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) )
                and m.data >= lac.dtinicio
                and m.data <= coalesce(lac.dtfim, current_date)
                and m.cdanimal = lac.cdanimal
                and m.data > m2.data
            order by m.data asc)
    left join mamite m4 on m4.cdmamite =
        (select first 1 m.cdmamite
            from mamite m
            where
                (((m.ad in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ad in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pd in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pd in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.ae in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.ae in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) or
                    ((m.pe in (0,1,2)) and (not exists
                    (select * from mamite re where re.cdanimal = m.cdanimal and re.pe in (0,1,2) and re.data between (m.data-13) and (m.data-1)))) )
                and m.data >= lac.dtinicio
                and m.data <= coalesce(lac.dtfim, current_date)
                and m.cdanimal = lac.cdanimal
                and m.data > m3.data
            order by m.data asc)
    left join reproducao ia1 on ia1.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = lac.cdanimal
                and re.data > lac.dtinicio
                and re.cdtiporeproducao in (1, 2, 3)
            order by re.data asc)
    left join reproducao ia1dig on ia1dig.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = ia1.cdanimal
                and re.data > ia1.data
            order by re.data asc)
where
    (lac.dtinicio - rep.data) >= 260
order by an.numordenado, lac.dtinicio

